pragma Ada_2022;
with Ada.Text_IO;
with Sets;
with Maps;
with Countries_And_Flags;
use all type Countries_And_Flags.Color;
use all type Countries_And_Flags.Country;

procedure Main is

   package Set_Of_Colors_Pkg is new Sets (Countries_And_Flags.Color);
   subtype Colors_Set is Set_Of_Colors_Pkg.Set;
   use all type Colors_Set;

   package Flags_Map_Pkg
     is new Maps (Countries_And_Flags.Country, Colors_Set);
   subtype Flags_Map is Flags_Map_Pkg.Map;
   use all type Flags_Map;

   Countries_Flags : Flags_Map := Make ([
      (Argentina, Make ([Blue, White, Yellow])),
      (Brazil, Make ([Green, White, Blue, Yellow])),
      (Netherlands, Make ([Red, White, Blue])),
      (UK, Make ([Red, White, Blue])),
      (France, Make ([Red, White, Blue])),
      (Germany, Make ([Red, Black, Yellow]))
   ]);

begin
   Ada.Text_IO.Put_Line (Countries_Flags'Image);

   for C in Countries_And_Flags.Color loop
      for KV of Countries_Flags loop
         if Has (KV.Val, C) then
            Ada.Text_IO.Put_Line (Countries_And_Flags.Country'Image (KV.Key) & " contains " & C'Image);
         end if;
      end loop;
   end loop;
end Main;
